Package com.sun.speech.freetts.en.us

# Class TokenToWords

java.lang.Object
com.sun.speech.freetts.en.us.TokenToWords

All Implemented Interfaces:
  `UtteranceProcessor`

public class TokenToWords extends Object implements UtteranceProcessor
Converts the Tokens (in US English words) in an Utterance into a list of words. It puts the produced list back into the Utterance. Usually, the tokens that gets expanded are numbers like "23" (to "twenty" "three").

* It translates the following code from flite:
`lang/usenglish/us_text.c`

## Constructor Summary

Constructors
Constructor
Description
`TokenToWords(CART usNumbersCART, PronounceableFSM prefixFSM, PronounceableFSM suffixFSM)`
Constructs a default USTokenWordProcessor.

## Method Summary

Modifier and Type
Method
Description
`Item`
`getTokenItem()`
Returns the currently processing token Item.
`boolean`
`isPronounceable(String word)`
Returns true if the given word is pronounceable.
`static boolean`
`kingLike(Item tokenItem)`
Returns true if the given token item contains a token that is in a king-like context, e.g., "King" or "Louis".
`void`
`processUtterance(Utterance utterance)`
process the utterance
`static boolean`
`sectionLike(Item tokenItem)`
Returns true if the given token item contains a token that is in a section-like context, e.g., "chapter" or "act".
`String`
`toString()`
Converts this object to its String representation

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### TokenToWords

public TokenToWords(CART usNumbersCART, PronounceableFSM prefixFSM, PronounceableFSM suffixFSM)
Constructs a default USTokenWordProcessor. It uses the USEnglish regular expression set (USEngRegExp) by default.

Parameters:
  `usNumbersCART` - the cart to use to classify numbers

## Method Details

### getTokenItem

public Item getTokenItem()
Returns the currently processing token Item.

Returns:
  the current token Item; null if no item

### processUtterance

public void processUtterance(Utterance utterance) throws ProcessException
process the utterance

Specified by:
  `processUtterance` in interface `UtteranceProcessor`
Parameters:
  `utterance` - the utterance contain the tokens
Throws:
  `ProcessException` - if an IOException is thrown during the processing of the utterance

### kingLike

public static boolean kingLike(Item tokenItem)
Returns true if the given token item contains a token that is in a king-like context, e.g., "King" or "Louis".

Parameters:
  `tokenItem` - the token item to check
Returns:
  true or false

### sectionLike

public static boolean sectionLike(Item tokenItem)
Returns true if the given token item contains a token that is in a section-like context, e.g., "chapter" or "act".

Parameters:
  `tokenItem` - the token item to check
Returns:
  true or false

### isPronounceable

public boolean isPronounceable(String word)
Returns true if the given word is pronounceable. This method is originally called us_aswd() in Flite 1.1.

Parameters:
  `word` - the word to test
Returns:
  true if the word is pronounceable, false otherwise

### toString

public String toString()
Converts this object to its String representation

Overrides:
  `toString` in class `Object`
Returns:
  the string representation of this object